#ifndef id4E5F8A0ABA6047BA988D512351B9DD2D
#define id4E5F8A0ABA6047BA988D512351B9DD2D

#include "doorkeeper/implem/doorkeeper_conf.h"

#if (defined(__clang__) && \
		(__clang_major__ == 3 && __clang_minor__ > 5) || (__clang_major__ > 3) \
	) || (defined(IS_ORIGINAL_GNUC) && \
		(__GNUC__ == 5 && __GNUC_MINOR__ >= 1) || (__GNUC__ > 5) \
	)
#	define IS_PRETTY_FUNC_CONSTEXPR
#elif defined(__GNUC__)
//uhm.. nothing :p
#else
#	error "Unknown compiler"
#endif

#if defined(IS_PRETTY_FUNC_CONSTEXPR)
#	include "doorkeeper/implem/string_bt.hpp"
#	include "doorkeeper/implem/tiger_bt.hpp"
#	include <stdexcept>
#endif
#include "doorkeeper/implem/compatibility.h"
#include <cstdint>
#include <ciso646>

namespace dk {
#if !defined(IS_PRETTY_FUNC_CONSTEXPR)
	struct HashType {
		uint64_t a;
		uint64_t b;
		uint64_t c;
	};
#endif

	bool operator< ( const HashType& parL, const HashType& parR );

	template <typename T, uint32_t D>
	HashType make_signature_hash ( void ) a_pure;

	namespace implem {
		HashType hash_string ( const char* parString, std::size_t parLen ) a_pure;
	} //namespace implem
} //namespace dk

#include "doorkeeper/implem/hashing.inl"

#if defined(IS_PRETTY_FUNC_CONSTEXPR)
#	undef IS_PRETTY_FUNC_CONSTEXPR
#endif

#endif
